<template>
  <div class="conversation-actions">
    <MakeCallBtn
      audio
      video
      :call-target="chat"
      :chat-id="chat.getId()"
    >
      <template #default="{ makeCall, disable }">
        <JActionIcon
          size="s"
          :disable="disable"
          class="call-with-camera"
          @click="makeCall"
          @keydown.space="makeCall"
          @keydown.enter="makeCall"
        >
          <JIcon
            icon="camera"
            size="24px"
          />
        </JActionIcon>
      </template>
    </MakeCallBtn>
    <MakeCallBtn
      audio
      :call-target="chat"
      :chat-id="chat.getId()"
    >
      <template #default="{ makeCall, disable }">
        <JActionIcon
          size="s"
          :disable="disable"
          class="call"
          @click="makeCall"
          @keydown.space="makeCall"
          @keydown.enter="makeCall"
        >
          <JIcon
            icon="phone"
            size="24px"
          />
        </JActionIcon>
      </template>
    </MakeCallBtn>
    <OpenChatInNewLayer
      v-slot="chatNewLayerSlotProps"
      :chat-id="chat.getId()"
    >
      <JActionIcon
        v-bind="chatNewLayerSlotProps"
        size="s"
        title="Chat dialog"
      >
        <JIcon
          icon="newLayer"
          size="24px"
        />
      </JActionIcon>
    </OpenChatInNewLayer>
    <JMenu
      v-if="chat.type === ChatTypes.Group"
      :close-on-click="false"
      auto-width
      :max-height="false"
    >
      <template #activator="menuProps">
        <JTeamCount
          v-bind="menuProps"
          :count="chat.members.length"
          class="ml-1 mr-3"
        />
      </template>

      <template #default="nestingMenuProps">
        <JMenu
          :close-on-click="false"
          :parent-menu-id="nestingMenuProps.parentMenuId"
        >
          <template #activator="menuProps">
            <JList class="members-menu j-scrollbar">
              <div
                v-for="user in chat.members"
                :key="user.id"
                v-bind="menuProps"
                @click.stop.prevent
              >
                <JListItem
                  size="m"
                  @click="selectedUser = user"
                  @keydown.space="selectedUser = user"
                  @keydown.enter="selectedUser = user"
                >
                  <UserAvatar
                    :avatar="user.avatar"
                    avatar-size="xs"
                    class="mr-2"
                  />
                  <JText
                    type="text-2"
                    color="secondary-title"
                    weight="normal"
                  >
                    {{ user.name }}
                  </JText>
                </JListItem>
              </div>
            </JList>
          </template>

          <UserProfile
            v-if="selectedUser"
            :user="selectedUser"
          />
        </JMenu>
        <JDivider
          height="0.5px"
          margin-top="6px"
          margin-bottom="6px"
        />
        <JList>
          <JListItem size="m">
            <LeaveGroupBtn
              :chat="chat"
              :tag="JText"
              type="text-2"
              color="secondary-title"
              weight="normal"
            />
          </JListItem>
        </JList>
      </template>
    </JMenu>
  </div>
</template>

<script setup lang="ts">
import { PropType, shallowRef } from 'vue';
import {
  JTeamCount, JMenu, JList, JListItem, JDivider, JActionIcon, JText, JIcon,
} from '@new-jira-clone/ui/src/components';
import { OpenChatInNewLayer } from '@/features/open-chat-in-new-layer';
import { LeaveGroupBtn } from '@/features/leave-group';
import { MakeCallBtn } from '@/features/make-call';
import { UserAvatar } from '@/entities/User';
import { ChatTypes, IChat, IUser } from '@/shared';
import { UserProfile } from '@/features/user-profile';

defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const selectedUser = shallowRef<IUser | null>(null);
</script>

<style scoped lang="scss">
.conversation-actions {
  display: flex;
  align-items: center;
}

.members-menu {
  max-height: 260px;
  min-width: 200px;
}

.call-with-camera,
.call {
  margin-right: 4px;
  color: rgb(var(--j-primary-color));
}
</style>
